macroScript GetSGC category:"RBR"
(
	--structures:
	struct sectionheader(offset,specA,specB,items,datasize,name)
	struct sceneobject (section,name, handle, parenthandle, pstmatrix,drawed,morphed)
	struct matdecl (unk1,matnamestr,matstatusstr, unk2, unk3, mateffectstr,unk4,unk5)	
	struct matdef (grouped,length,name,type,texcount,texnamesarr,texparamsarr,matparams)	
	struct decomppivotmatrix(T,Q,U,S)
	struct deformation (name, type, params)
	
	--functions: 
	function readvertarray f vertcount = 
	(
		vertarray = #()
		for vi = 1 to vertcount do
		(
			x = readfloat f
			y = readfloat f
			z = readfloat f
			append vertarray [x, y, z]
		)--for v = 1 to vertcount
		vertarray	
	)
	function objnamefromhandle objects handle = 
	(
		aname = ""
		for o in objects do
		(
			if o.handle == handle then
			(
				aname = o.name
				exit
			)			
		)
		aname 
	)
	
	function pstmxfromhandle objects handle = 
	(
		pst = 0
		for o in objects do
		(
			if o.handle == handle then
			(				
				parentasnode = getNodeByName o.name
				pst = parentasnode.transform
				exit
			)			
		)
		pst 
	)
	function applypst anode ost pst = 
	(
		--print "\tApply parent transformation :"
		--format "\t ost: %\n" ost
		--format "\t pst: %\n" pst
		--newwmtx = xformmat ost pst		
		--newmtx.row4 = ost.row4 + pst.row4
		--format "\t newmtx: %\n" newmtx
		mytransform = anode.transform
		mytransform.row1 = ost.row1
		mytransform.row2 = ost.row2
		mytransform.row3 = ost.row3
		mytransform.row4 = ost.row4 + pst.row4
		--format "\t mytransform: %\n" mytransform
		anode.transform = mytransform	
	)
	
	function applyost anode ost  = 
	(
		--print "\tApply object transformation :"
		--format "\t ost: %\n" ost
		mytransform = anode.transform
		mytransform = ost
		anode.transform = mytransform	
	)
						
	function readpstmtx f = --parent space transformational matrix
	(			
		here = ftell f
		--format "\tattempt to read raw matrix at %\n" here
		r = #()
		for c = 1 to 12 do
		(		
			aparam = readfloat f
			append r aparam					
		)	
		pstmatrix = matrix3 1
		pstmatrix.row1 = [r[1], r[5], r[9]] 
		pstmatrix.row2 = [r[2], r[6], r[10]] 
		pstmatrix.row3 = [r[3], r[7], r[11]] 
		pstmatrix.row4 = [r[4], r[8], r[12]]
		--format "\t\traw matrix: %\n" r
		--format "\t\treaded matrix: %\n" pstmatrix
		pstmatrix
	)
	function readdecomppivotmatrix f = 
	(
		T = #()
		Q = #()
		U = #()
		S = #()
		for ii = 1 to 3 do
		(
			afloat = readfloat f
			append T afloat
		)									
		for ii = 1 to 4 do
		(
			afloat = readfloat f
			append Q afloat
		)								
		for ii = 1 to 4 do
		(
			afloat = readfloat f
			append U afloat
		)								
		for ii = 1 to 3 do
		(
			afloat = readfloat f
			append S afloat
		)
		adecpvmat = decomppivotmatrix T Q U S
		adecpvmat
	)
	function readmatdecl offset f verbose = 
	(
		fseek f offset #seek_set	
		amatdecl = matdecl 0 0 0 0 0 0 0 0  		
		amatdecl.unk1 = readlong f
		amatdecl.matnamestr = readstring f
		amatdecl.matstatusstr = readstring f
		amatdecl.unk2 = readlong f
		amatdecl.unk3 = readlong f
		amatdecl.mateffectstr = readstring f
		amatdecl.unk4 = readlong f
		amatdecl.unk5 = readlong f	
		if verbose then 
		(
			format"%\n" amatdecl
		)
		amatdecl	
	)
	-------------------------
	function readsectionheader f = 
	(
		asectheader = sectionheader 0 0 0 0 0 0 
		asectheader.offset = ftell f
		separator = readlong f		
		asectheader.specA 		= readlong f
		asectheader.specb 		= readlong f
		asectheader.items 		= readlong f
		asectheader.datasize 	= readlong f
		asectheader.name = readstring f
		--print asectheader
		asectheader
	)
		
	function readmatdef offset f isgrouped verbose = 
	(
		fseek f offset #seek_set
		amatdef = matdef 0 0 0 0 0 0 0
		amatdef.grouped = isgrouped
		amatdef.length = readlong f
		amatdef.name = readstring f
		amatdef.type = readlong f
		amatdef.texnamesarr = #()
		amatdef.texparamsarr = #()
		texcount = 0
		if (amatdef.type == 1) then 
		texcount = 1
		else 
			if (amatdef.type == 3) then
			texcount = 2
			
		if (texcount != 0) then
		(	
			for t = 1 to texcount do
			(
				atexname = readstring f
				append amatdef.texnamesarr atexname
				atexparam = #()
				for p = 1 to 8 do
				(
					aparam = readfloat f
					append atexparam aparam
				)
				append amatdef.texparamsarr atexparam
			)
		)
		
		amatdef.matparams = #()
		for p = 1 to 13 do
		(
			aparam = readfloat f
			append amatdef.matparams aparam
		)		
		--print amatdef.name
		--print amatdef.type
		--print texcount
		--print amatdef.texnamesarr
		--print amatdef.texparamsarr	
		if verbose then 
		(			
			format "Matdef grouped % offset % matdef name %  type % texturecount % :\n" amatdef.grouped offset amatdef.name amatdef.type texcount
			if texcount != 0 then 
			(
				for t =  1 to texcount do 
				(
					format "\t %  - " amatdef.texnamesarr[t]
					format "\t %\n" amatdef.texparamsarr[t]
				)
			)
			format "\t mat params  :%\n\n" amatdef.matparams
		) -- if verbose
		amatdef						
	)
		
undo off
(
----**************************************************************************************************************
----************************************************************************************* START OF INI PROCESSING
----**************************************************************************************************************
	filename = getopenfilename \
						types: "ini(*.ini)|*.ini|All|*.*|"	
						
if filename != undefined then
(
	f = openfile filename mode:"rt"	
	print f
	--fseek f 0 #seek_end
	--filesize = ftell f	
	--format "filesize %\n" filesize

	lines = #()
	seek f 0
	aline = readline f
	append lines aline
	linescount = 0
	while aline != undefined do
	(
		aline = readline f
		append lines aline
		linescount += 1
		if eof f then exit
	)
	--print lines
	fclose f
	counter = 0
	struct objline(name,index,position,normal)
	objlines = #()
	for l = 1 to linescount do
	(
		if (lines[l][1] == "[") then
		(
			strarr = filterstring lines[l] "[]"
			--print strarr
			counter += 1
			aobjline = objline strarr[1] l [0,0,0] [0,0,0]
			append objlines aobjline			
		)
	)
	for oli = 1 to (counter-1) do
	(
		for k = (objlines[oli].index + 1) to (objlines[oli+1].index-1)do
		(
			--print lines[k]
			if (matchpattern lines[k] pattern:"Pos*" ignorecase:false) then
			(
				--print lines[k]
				strarr = filterstring lines[k] " "
				x = strarr[3] as float
				y = strarr[4] as float
				z = strarr[5] as float
				objlines[oli].position = [x,y,z]
				--format "INI POSITION nx = %, ny = %, nz = %\n" x y z

			)
			if (matchpattern lines[k] pattern:"Normal*" ignorecase:false) then
			(
				--print lines[k]
				strarr = filterstring lines[k] " "
				x = strarr[3] as float
				y = strarr[4] as float
				z = strarr[5] as float
				--format "nx = %, ny = %, nz = %\n" x y z
				--apoint = point size:100 pos:[x*1000, y*1000,z*1000] name:objlines[oli].name
				objlines[oli].normal = [x,y,z]
			)
		)
	)
	fclose f
	/*
	for oli = 1 to counter do
	(
		--anode = point size:100 pos:objlines[oli].position name:objlines[oli].name
		anode = getNodeByName objlines[oli].name
		--aquat = quat objlines[oli].normal[1] objlines[oli].normal[2] objlines[oli].normal[3] 0
		--print aquat
		--aeuler = quattoeuler aquat order:1
		--print aeuler
		rot_node = eulerangles 90 0 0
		rotate anode rot_node
		anode.pos = objlines[oli].position
	)*/
)
----********************************************************************************************************
----************************************************************************************* END OF INI THINGS
----********************************************************************************************************
	filename = getopenfilename \
						types: "sgc(*.sgc)|*.sgc|All|*.*|"	
						
if filename != undefined then
(
	f = fopen filename "rb"	
	print f
	fseek f 0 #seek_end
	filesize = ftell f
	format "filesize %\n" filesize
	nextoffset = 0
	
	fseek f 0 #seek_set	
	fileheader = #()
	for i = 1 to 23 do
	(
		abyte = readbyte f
		append fileheader abyte		
	)
	nextoffset = ftell f
	
/***********************************************************************************************/
/*                                 DRAW OBJECT FUNCTION                                       */
/***********************************************************************************************/
		
	function drawobject sections scobj = 
	(
		verbose = true
		--- struct sceneobject (section,name, handle, parenthandle, pstmatrix,drawed,morphed)
		aheader = sections[scobj.section]				
		name = "undefined name"
		anode = undefined
		draw = true
-- Point helpers		
		if ((aheader.specA == 22) and (aheader.specB == 0)) then
		(		
			--print "try point helper"					
			fseek f (aheader.offset+20) #seek_set
			name = readstring f
			handle = readlong f
			parenthandle = readlong f			
			adcmppvtmtx =  readdecomppivotmatrix f		
			format "\tdecomposed       \t\t\t\t%\n" adcmppvtmtx	
			pstmatrix = readpstmtx f 		
			format "\tin-section matrix\t\t\t\t%\n" pstmatrix		
			anode = point size:0.01 centermarker: false box: false cross:true pos:[0, 0, 0] name:name		
			applyost anode pstmatrix										
		)--if ((aheader.specA == 22) and (aheader.specB == 0))
-- Dummy helpers
		if ((aheader.specA == 3) and (aheader.specB == 13)) then
		(	
			--print "try dummy helper"
			fseek f (aheader.offset+20) #seek_set
			name = readstring f
			handle = readlong f
			parenthandle = readlong f			
			adcmppvtmtx =  readdecomppivotmatrix f	
			format "\tdecomposed       \t\t\t\t%\n" adcmppvtmtx						
			pstmatrix = readpstmtx f 	
			format "\tin-section matrix\t\t\t\t%\n" pstmatrix			
			anode = dummy boxsize:[0.01,0.01,0.01]  pos:[0,0, 0] name: name		
			applyost anode pstmatrix			
		)--if ((aheader.specA == 3) and (aheader.specB == 13))	
		
-- Shadow "makers"
		if ((aheader.specA == 17) and (aheader.specB == 0)) then
		(		
			fseek f (aheader.offset+20) #seek_set	
			sectionend = (ftell f)+ aheader.datasize		
			name = readstring f	
			handle = readlong f
			parenthandle = readlong f			
			adcmppvtmtx =  readdecomppivotmatrix f	
			format "\tdecomposed       \t\t\t\t%\n" adcmppvtmtx						
			pstmatrix = readpstmtx f 
			format "\tin-section matrix\t\t\t\t%\n" pstmatrix						
			vertcount = readlong f
			vertarray = readvertarray f vertcount			
			facecount = readlong f
			facearray = #()
			normalarray = #()			
			for fi = 1 to facecount do
			(
				a = (readlong f) + 1
				b = (readlong f) + 1
				c = (readlong f) + 1 
				na = readfloat f
				nb = readfloat f
				nc = readfloat f
				append facearray [a,b,c]
				append normalarray [na, nc, nb]
			)--for fi = 1 to facecount									
			anode = mesh vertices:vertarray faces:facearray  name: name
			--applyost anode pstmatrix
			for fi = 1 to facecount do
			(
				setfacenormal anode fi normalarray[fi]
			)			
			unknownarr = #()
			unkcount = readlong f
			for ui = 1 to unkcount do
			(
				along = readlong f
				append unknownarr along
			)						
		)--if ((sections[s].specA == 17) and (sections[s].specB == 0))		
-- Not morphed objects
		if ((aheader.specA == 0) and (aheader.specB == 1)) then
		(							
			fseek f (aheader.offset+20) #seek_set			
			name = readstring f	
			handle = readlong f
			parenthandle = readlong f			
			adcmppvtmtx =  readdecomppivotmatrix f		
			format "\tdecomposed       \t\t\t\t%\n" adcmppvtmtx										
			pstmatrix = readpstmtx f 	
			format "\tin-section matrix\t\t\t\t%\n" pstmatrix		
			auxparams = #()
			for axi = 1 to 6 do
			(
				auxparam = readfloat f
				append auxparams (auxparam*1000)
			)						
			vertcount = readlong f
			acount = readlong f
			vertarray = #()
			normalarray = #()	
			uvarray = #()
			for vi = 1 to vertcount do
			(
				x = readfloat f
				y = readfloat f
				z = readfloat f
				append vertarray [x, y, z]				
				nx = readfloat f
				ny = readfloat f
				nz = readfloat f 
				append normalarray [nx, ny, nz]
			)								
			if (acount == 23) then
			(
				for vi = 1 to vertcount do
				(
					u = readfloat f
					v = readfloat f
					append uvarray [u, v]
				)		
			)
			for vi = 1 to vertcount do
			(
				ffffffff = readlong f
			)						
			facecount = readlong f
			facearray = #()
			for fi = 1 to facecount do
			(
				a = (readshort f) + 1
				b = (readshort f) + 1
				c = (readshort f) + 1 
				append facearray [a,b,c]			
			)--for fi = 1 to facecount
			anode = mesh vertices:vertarray faces:facearray  normals:normalarray name:scobj.name	
			--applyost anode pstmatrix						
			matcount = readlong f
			for mi =  1 to matcount do			
			(
				matname = readstring f
				matfacecount = readlong f
				matfirstface = readlong f
				matvertcount = readlong f
				matfirstvert = readlong f
			)		
			testcollmap = readlong f
			here = ftell f			
																	
		)--if ((sections[s].specA == 0) and (sections[s].specB == 1))
-- Morphed objects
		if ((aheader.specA == 0) and (aheader.specB == 3)) then
		(							
			fseek f (aheader.offset+20) #seek_set			
			name = readstring f	
			handle = readlong f
			parenthandle = readlong f			
			adcmppvtmtx =  readdecomppivotmatrix f	
			format "\tdecomposed       \t\t\t\t%\n" adcmppvtmtx											
			pstmatrix = readpstmtx f 
			format "\tin-section matrix\t\t\t\t%\n" pstmatrix				
			auxparams = #()
			for axi = 1 to 6 do
			(
				auxparam = readfloat f
				append auxparams (auxparam*1000)
			)--for axi = 1 to 6							
			here = ftell f
			format "Vertex start: %\n" here
			vertcount = readlong f
			acount = readlong f
			vertarray = #()
			normalarray = #()	
			uvarray = #()
			for vi = 1 to vertcount do
			(
				x = readfloat f
				y = readfloat f
				z = readfloat f
				append vertarray [x, y, z]				
				nx = readfloat f
				ny = readfloat f
				nz = readfloat f				
				append normalarray [nx, ny, nz]
			)--for vi = 1 to vertcount	
			
			here = ftell f
			format "Vertex end: %\n" here	
						
			if (acount == 23) then
			(
				for vi = 1 to vertcount do
				(
					u = readfloat f
					v = readfloat f
					append uvarray [u, v,0]
				)--for vi = 1 to vertcount		
			)--if (acount == 23)
			for vi = 1 to vertcount do
			(
				ffffffff = readlong f
			)--for vi = 1 to vertcount						
			facecount = readlong f
			facearray = #()
			for fi = 1 to facecount do
			(
				a = (readshort f) + 1
				b = (readshort f) + 1
				c = (readshort f) + 1 
				append facearray [a,b,c]			
			)--for fi = 1 to facecount			
			if (not scobj.morphed) then
			(
				anode = mesh vertices:vertarray faces:facearray normals:normalarray name:scobj.name
				--applyost anode pstmatrix
				anode.numtverts = anode.numverts
				buildtvfaces anode 
				for vi = 1 to vertcount do
				(
					settvert anode vi uvarray[vi]
				)--for vi = 1 to vertcount do
				for fi = 1 to facecount do
				(
					settvface anode fi facearray[fi]	
				)--for fi = 1 to facecount	
			)						
			matcount = readlong f
			for mi =  1 to matcount do			
			(
				matname = readstring f
				matfacecount = readlong f
				matfirstface = readlong f
				matvertcount = readlong f
				matfirstvert = readlong f
			)--for mi =  1 to matcount					
			here = ftell f
			separator = readlong f
			morphedvertcount = readlong f
			--format "vertcount % morphedpointscount %\n" vertcount morphedvertcount
			morphedvertarray = #()
			abyte = readbyte f
			for vi = 1 to morphedvertcount do
			(
				x = (readfloat f)*100
				x += vertarray[vi][1]
				y = (readfloat f)*100
				y += vertarray[vi][2]
				z = (readfloat f)*100
				z += vertarray[vi][3]
				append morphedvertarray [x, y, z]	
				--format " % >>>>>>>>> %\n" vertarray[vi]	morphedvertarray[vi]		
			)			
			if (scobj.morphed) then 
			(
				scobj.name[1] = "d"
				anode  = mesh vertices:morphedvertarray faces:facearray normals:normalarray name:scobj.name			
				--applyost anode pstmatrix
			)
			testcollmap = readlong f			
			here = ftell f																		
		)--if ((sections[s].specA == 0) and (sections[s].specB == 3))			
-- Collision bodies
		if ((aheader.specA == 16) and (aheader.specB == 0)) then
		(			
			fseek f (aheader.offset+20) #seek_set	
			sectionend = (ftell f)+ aheader.datasize					
			name = readstring f					
			handle = readlong f
			parenthandle = readlong f			
			adcmppvtmtx =  readdecomppivotmatrix f	
			format "\tdecomposed       \t\t\t\t%\n" adcmppvtmtx					
			pstmatrix = readpstmtx f 	
			format "\tin-section matrix\t\t\t\t%\n" pstmatrix				
			if (name == "c_e_body") then
			(
				vertcount = readlong f
				vertarray = #()
				for vi = 1 to vertcount do
				(
					x = readfloat f
					y = readfloat f
					z = readfloat f
					append vertarray [x, y, z]
				)--for v = 1 to vertcount
				uvcount = readlong f	
				uvarray = #()
				if (uvcount != 0) then
				(
					for uvi = 1 to uvcount do
					(
						u = readfloat f
						v = readfloat f
						append uvarray [u, v]
					)
				)
				--format "uvcount %\n" uvcount							
				facecount = readlong f
				--format "facecount %\n" uvcount
				facearray = #()
				for fi = 1 to facecount do
				(
					a = (readlong f) + 1
					b = (readlong f) + 1
					c = (readlong f) + 1 
					uva = (readlong f) + 1 
					uvb = (readlong f) + 1 
					uvc = (readlong f) + 1 
					append facearray [a,b,c]
				)--for fi = 1 to facecount	
				here = ftell f
				--format "************************************************************************textures offset %\n" here									
				anode = mesh vertices:vertarray faces:facearray  name:scobj.name	
				--applyost anode pstmatrix		
				texturetest = readbyte f
				
				if (texturetest == 1) then
				(
					texturename = readstring f				
					len = readlong f
					abyte = readbyte
					for ti = 1 to len*len do
					(
						abyte = readbyte f
					)
					texturename = readstring f				
					len = readlong f
					abyte = readbyte
					for ti = 1 to len*len do
					(
						abyte = readbyte f
					)
				)
			)--if (name == "c_e_body")
			
			else
			(
				vertcount = readlong f
				vertarray = #()
				for vi = 1 to vertcount do
				(
					x = readfloat f
					y = readfloat f
					z = readfloat f
					append vertarray [x, y, z]
				)--for v = 1 to vertcount
				uvcount = readlong f	
				uvarray = #()
				if (uvcount != 0) then
				(
					for uvi = 1 to uvcount do
					(
						u = readfloat f
						v = readfloat f
						append uvarray [u, v]
					)
				)
				--format "uvcount %\n" uvcount							
				facecount = readlong f
				--format "facecount %\n" uvcount
				facearray = #()
				for fi = 1 to facecount do
				(
					a = (readlong f) + 1
					b = (readlong f) + 1
					c = (readlong f) + 1 
					if (uvcount != 0) then
					(
						uva = (readlong f) + 1 
						uvb = (readlong f) + 1 
						uvc = (readlong f) + 1 
					)
					append facearray [a,b,c]
				)--for fi = 1 to facecount										
				anode = mesh vertices:vertarray faces:facearray  name: name		
				--applyost anode pstmatrix
				texturetest = readbyte f		
			)
			here = ftell f
			sectionparsed = true
		)--if ((sections[s].specA == 16) and (sections[s].specB == 0))

-- Cameras >>
		if ((aheader.specA == 2) and (aheader.specB == 11)) then
		(					
			fseek f (aheader.offset+20) #seek_set
			name = readstring f
			handle = readlong f
			parenthandle = readlong f			
			adcmppvtmtx =  readdecomppivotmatrix f	
			format "\tdecomposed       \t\t\t\t%\n" adcmppvtmtx					
			nearclip = readfloat f
			farclip = readfloat f
			fovradian = readfloat f			
			pstmatrix = readpstmtx f 			
			unkparam = readfloat f
			targetpos = #()			
			for auxi = 1 to 3 do
			(
				auxp = readfloat f
				append targetpos  auxp
			)	
			pi = 3.1415926535897932384626433832795
			fovdeg = 180*fovradian/pi 
			targetname = name + ".Target"
			--targetnode  = Targetobject transform:(matrix3 [1,0,0] [0,1,0] [0,0,1] [targetpos[1],targetpos[2],targetpos[3]]) name: targetname
			targetnode  = Targetobject pos:[targetpos[1],targetpos[2],targetpos[3]] name: targetname

			parentnode = getNodeByName "parent"
			targetnode.parent = parentnode
			anode = targetcamera type: #target fov:fovdeg pos:[0,0,0] nearclip: nearclip farclip:farclip name:scobj.name\
												 target:targetnode 
			--applyost anode pstmatrix	
		)--if ((sections[s].specA == 2) and (sections[s].specB == 11))	<< Cameras		
		
		if anode == undefined then 
		(	
			format "FAILED %\n" scobj
			anode = point size:0.01 centermarker: false box: false cross:true pos:[0, 0, 0] name:"fake"
		)
		anode		
	)
-----------------------------------------------------------------------------

	
-----------------------------------------------------------------------------
---| GLOBALS:
-----------------------------------------------------------------------------		
---| FILE SECTIONS :
-----------------------------------------------------------------------------
	sections = #()
	sectionscount = 0
-----------------------------------------------------------------------------
--- Sort file's sections into sections table "sections = #()"
	while nextoffset < (filesize-4) do 
	(		
		fseek f nextoffset #seek_set
		aheader = readsectionheader f
		append sections aheader
		sectionscount += 1
		nextoffset = aheader.offset + aheader.datasize + 20			
	)--while nextoffset < (filesize-4) do 
-----------------------------------------------------------------------------		
---| OBJECT ENTRIES :
-----------------------------------------------------------------------------
---| OBJECTS AS IN 	section "12-18-0" - Object declarations section
	
---| Search and sort scene objects declarations into table "sceneobjects = #()"
	objectentriescount = 0
	objectentries = #()
	for s = 1 to sectionscount do  
	(
	-- "12-18-0" ******************************************************************
	-- Objects declarations
		if ((sections[s].specA == 18) and (sections[s].specB == 0)) then
		(
			verbose = false
			fseek f (sections[s].offset+20) #seek_set			
			objectcount = readlong f
			sceneobjectscount = objectcount	
			objectentry					
			nextoffset = ftell f			
			for k =1 to objectcount do 
			(		
				fseek f nextoffset #seek_set
				objectentry = readsectionheader f
				append objectentries  objectentry
				nextoffset = objectentry.offset + objectentry.datasize + 20	
				objectentriescount += 1 
			)--for k =1 to objectcount 					
		)--if ((sections[s].specA == 18) and (sections[s].specB == 0))		
	)--for s = 1 to sectionscount do (search for sceneobject declaration section)==end
	print "**************************   OBJECT ENTRIES    ************************************"

-----------------------------------------------------------------------------		
---| DEFORMATIONS :
-----------------------------------------------------------------------------

	deformationsscount = 0
	deformations = #()
-- "12-6-21" ******************************************************************
-- Deformations : Morphers and PRSs
	for s = 1 to sectionscount do  
	(
	
		if ((sections[s].specA == 6) and (sections[s].specB == 21)) then
		(		
			-- struct deformation (name, type, params)
			
			verbose = false	
			fseek f (sections[s].offset+20) #seek_set
			sectionend = (ftell f)+ sections[s].datasize			
			name = readstring f	
			adeformation = deformation name 0 0		
			
			--format "\n% \t(%, %) \n****\n" name	 sections[s].offset	sectionend		
		
			subsections = 	#()
			subsectionscount = 0
 			nextoffset = ftell f
			while (nextoffset < (sectionend - 4)) do 
			(		
				fseek f nextoffset #seek_set
				--format "\tnextoffset : %\n" nextoffset
				subsectionheader = readsectionheader f
				append subsections subsectionheader
				subsectionscount += 1
				nextoffset = subsectionheader.offset + subsectionheader.datasize
				nextoffset += 20			
			)--while (nextoffset < (sectionend - 4))
			--format "\tSubsections count : %\n" subsectionscount 	
			for ssh in subsections do
			(
			 	-- format"\t\t%\n" ssh				
				if ((ssh.specA == 11) and (ssh.specB == 24)) then								-- ROLL OR MORPHER CASE 
				(
					shortname = ""
					for strpos = 1 to name.count do
					(
						if name[strpos] != ":" then
						(
							append shortname name[strpos]
						)--if name[strpos] != ":"
						else exit
					)--for strpos = 1 to name.count					
					threefromtail = ""
					for strpos = (shortname.count - 2) to shortname.count do
					(
							append threefromtail shortname[strpos]
					)--for strpos = (shortname.count - 2) to shortname.count
					if ((shortname[1] == "e") and (threefromtail != "lit"))  then 	
					(				
						--print shortname	
						--damaged += 1
					)--if ((shortname[1] == "e") and (threefromtail != "lit")) 					
					fseek f (ssh.offset + 20) #seek_set
					paramheader = readsectionheader f
					--format"\t\t\t%\n" paramheader
					if ((paramheader.specA == 13) and (paramheader.specB == 46)) then
					(
						params = #()
						for pindex = 1 to 5 do
						(
							aparam = readfloat f
							append params aparam
						)-- for pindex = 1 to 5
						adeformation = deformation name 0 params
						--format "\t\t\t\tparameters: %\n" params
					)--if ((paramheader.specA == 13) and (paramheader.specB == 46))
				)-- if ((ssh.specA == 11) and (ssh.specB == 24))								
				if ((ssh.specA == 7) and (ssh.specB == 33)) then										-- PRS CASE 
				(
					fseek f (ssh.offset + 20) #seek_set
					pdm = readdecomppivotmatrix f 
					adeformation = deformation name "PRS" pdm
					--format "\t\t\t\tparameters: %\n" pdm
				)-- if ((ssh.specA == 7) and (ssh.specB == 33))					
				
				if ((ssh.specA == 8) and (ssh.specB == 31)) then										-- POSITION CASE A
				(
					fseek f (ssh.offset + 20) #seek_set
					subsectionnend = (ftell f)+ ssh.datasize
					nextoffset = ftell f
					chunks = #()
					chunkscount = 0
					while (nextoffset < (subsectionnend - 4)) do 
					(		
						fseek f nextoffset #seek_set
						--format "\tnextoffset : %\n" nextoffset	
						chunkheader = readsectionheader f
						append chunks chunkheader
						chunkscount += 1
						nextoffset = chunkheader.offset + chunkheader.datasize
						nextoffset += 20			
					)--while (nextoffset < (subsectionnend - 4))
					allparams = #()
					for ck in chunks do
					(
						--format"\t\t\t%\n" ck
						if ((ck.specA == 11) and (ck.specB == 24)) then
						(
							fseek f (ck.offset + 20) #seek_set
							paramheader = readsectionheader f
							--format"\t\t\t\t%\n" paramheader
							if ((paramheader.specA == 13) and (paramheader.specB == 46)) then
							(
								params = #()
								for pindex = 1 to 5 do
								(
									aparam = readfloat f
									append params aparam
								)-- for pindex = 1 to 5
								--format "\t\t\t\t\tparameters: %\n" params
							)-- if ((paramheader.specA == 13) and (paramheader.specB == 46))	
							append allparams params
						)-- if ((ck.specA == 11) and (ck.specB == 24)) 						
					)--for ck in chunks 
					adeformation = deformation name "POSITION A" allparams
				)-- if ((ssh.specA == 8) and (ssh.specB == 31))						
				if ((ssh.specA == 8) and (ssh.specB == 26)) then                                	-- POSITION CASE B
				(
					fseek f (ssh.offset + 20) #seek_set
					paramheader = readsectionheader f
					--format"\t\t\t%\n" paramheader
					if ((paramheader.specA == 13) and (paramheader.specB == 43)) then
					(
						params = #()
						for pindex = 1 to 7 do
						(
							aparam = readfloat f
							append params aparam
						)-- for pindex = 1 to 5
						--format "\t\t\t\tparameters: %\n" params
						adeformation = deformation name "POSITION B" params
					)--if ((paramheader.specA == 13) and (paramheader.specB == 46))					
				)-- if ((ssh.specA == 11) and (ssh.specB == 24))								
				if ((ssh.specA == 10) and (ssh.specB == 0)) then                                   	-- SCALE CASE 
				(
					fseek f (ssh.offset + 20) #seek_set
					paramheader = readsectionheader f
					--format"\t\t\t%\n" paramheader
					if ((paramheader.specA == 13) and (paramheader.specB == 45)) then
					(
						params = #()
						for pindex = 1 to 11 do
						(
							aparam = readfloat f
							append params aparam
						)-- for pindex = 1 to 5
						--format "\t\t\t\tparameters: %\n" params
						adeformation = deformation name "SCALE " params
					)--if ((paramheader.specA == 13) and (paramheader.specB == 45))
				)-- if ((ssh.specA == 10) and (ssh.specB == 0))		
										
			)-- for ssh in subsections 		
		append deformations adeformation							
		)--if ((sections[s].specA == 6) and (sections[s].specB == 21))	

	)--for s = 1 to sectionscount
for d in deformations do
(
	format "%:\n" d.name
	format "\t%\n" d.type
	format "\t%\n" d.params
)-- for d in deformations
	
-----------------------------------------------------------------------------		
---| SCENE ENTRIES :
-----------------------------------------------------------------------------	

	sceneobjectscount = 0
	sceneobjects = #()
	morphedsceneobjectscount = 0
	morphedsceneobjects = #()
	for oe in objectentries do  
	(	
		--- struct sceneobject (section,name, handle, parenthandle, pstmatrix,drawed,morphed)
		asceneobject = sceneobject -1 oe.name 0 0 0 false false
		for s = 1 to sectionscount do
		(
			if (oe.name == sections[s].name) then
			(

				asceneobject.section = s
				fseek f (oe.offset+20) #seek_set	
				objname = readstring f -- skipping name's bytes
				asceneobject.handle = readlong f
				asceneobject.parenthandle = readlong f	
				asceneobject.pstmatrix = readpstmtx f 
				append sceneobjects asceneobject
				sceneobjectscount += 1
				exit				
			)
		)

		if (asceneobject.name[1] == "d") then
		(
			asceneobject.morphed = true
			unmorphedname = asceneobject.name
			unmorphedname[1] = "e"			
			for s = 1 to sectionscount do
			(
				if (unmorphedname == sections[s].name) then
				(		
					asceneobject.section = s
					fseek f (oe.offset+20) #seek_set	
					objname = readstring f -- skipping name's bytes
					asceneobject.handle = readlong f
					asceneobject.parenthandle = readlong f	
					asceneobject.pstmatrix = readpstmtx f 
					append sceneobjects asceneobject
					sceneobjectscount += 1
					exit				
				)--if (unmorphedname == sections[s].name)
			)--for s = 1 to sectionscount				
		)--if (asceneobject.name[1] == "d")
		
		if (asceneobject.section == -1) then 
		(
			format "no section found for % \n" oe
		)--if (asceneobject.section == -1) 
	)
	print "**************************   SCENEOBJECTS OBJECTS    ************************************"
	format "section count = %\n" sectionscount
	format "objectentries count = %\n" objectentriescount
	format "sceneobjectscount count = %\n" sceneobjectscount
	--print sections
	--print objectentries
	--print sceneobjects

/***********************************************************************************************/
/*                                HIERARCHY SORT 			                                   */
/***********************************************************************************************/	


	carparent  = undefined
	remaining = objectentriescount
	while (remaining  > 0) do
	(
		temprema =  remaining
		print remaining
		for sobj in sceneobjects do
		(
			if (not sobj.drawed) then
			(		
				if (sobj.parenthandle == -1)then
				(	
					anode =  drawobject sections sobj  				
					pst  = matrix3 1		
					print sobj.name
					format "\tobject entry matrix\t\t\t\t%\n" sobj.pstmatrix
					format "\tparent matrix      \t\t\t\t%\n" pst							
					applyost anode sobj.pstmatrix
					remaining  -= 1
					sobj.drawed = true	
									
				)--if (sobj.parenthandle == -1)
				else	
				(
					parentname = objnamefromhandle sceneobjects sobj.parenthandle
					parentnode = getNodeByName parentname
					if ((parentnode != undefined)) then
					(	
						if not (matchpattern sobj.name pattern:"*Target*" ignorecase:false) then
						(
							anode =  drawobject sections sobj  					
							pst = pstmxfromhandle sceneobjects sobj.parenthandle	
							print sobj.name
							format "\tobject entry matrix\t\t\t\t%\n" sobj.pstmatrix
							format "\tparent matrix      \t\t\t\t%\n" pst
							applypst anode sobj.pstmatrix pst							
							anode.parent = parentnode
							remaining  -= 1
							sobj.drawed = true

							for oli in objlines do
							(
								--anode = point size:100 pos:objlines[oli].position name:objlines[oli].name
								--anode = getNodeByName objlines[oli].name
								--aquat = quat objlines[oli].normal[1] objlines[oli].normal[2] objlines[oli].normal[3] 0
								--print aquat
								--aeuler = quattoeuler aquat order:1
								--print aeuler
								if oli.name == sobj.name then 
								(
									--rot_node = eulerangles 90 0 0
									--rotate anode rot_node
									--anode.pos = oli.position
									format "\tINI POSITION \t\t\t%\n" oli.position
									format "\tINI NORMAL   \t\t\t%\n" oli.normal
								)--if oli.name == sobj.name
							)--for oli in objlines
							
						)
					)
				)-- else/if (sobj.parenthandle == -1)							
			)-- if (not sobj.drawed)	
		)--for sobj in sceneobjects
		
		tempremb = remaining 
		if (temprema == tempremb) then
		(
			remaining = 0
			print remaining			
		)
	)--while (remaining  > 0)
	


---------*********************************************************************

/*
parse = false
if parse then
(	
print "start parse ........................................................................"
	for s = 1 to  sectionscount do
	(
		sectionparsed = false
-- "12-15-54 " ******************************************************************
-- Material declarations
		if ((sections[s].specA == 15) and (sections[s].specB == 54)) then
		(
			amdec = readmatdecl (sections[s].offset+20) f false
			sectionparsed = true
		)-- if ((sections[s].specA == 15) and (sections[s].specB == 54))
		
-- "12-5-18 " ******************************************************************
-- Material definitions		
		if ((sections[s].specA == 5) and (sections[s].specB == 18)) then
		(
			amatdef = readmatdef (sections[s].offset+16) f false false
			sectionparsed = true
		)--if ((sections[s].specA == 5) and (sections[s].specB == 18))	
	
-- "12-5-17 " ******************************************************************
-- Grouped material definitions			
		if ((sections[s].specA == 5) and (sections[s].specB == 17)) then
		(
			verbose = false
			--print sections[s]
			fseek f (sections[s].offset+20) #seek_set								
			groupname = readstring f
			groupitemcount = readlong f
			if verbose then	format "group % : %\n" groupname groupitemcount	
			groupdatastart = ftell f
			nextoffset = groupdatastart			
			groupsections = #()
			groupsectionscount = 0			
			groupstart = sections[s].offset
			--print groupstart
			groupdatasize = sections[s].datasize
			--print groupdatasize			
			groupend = (groupdatastart + groupdatasize - 4)
			--print groupend			
			for k =1 to groupitemcount do 
			(		
				fseek f nextoffset #seek_set
				separator = readlong f	
				aheader = sectionheader  0 0 0 0
				aheader.offset = nextoffset 
				aheader.specA = readlong f
				aheader.specB = readlong f		
				aheader.items = readlong f		
				aheader.datasize    = readlong f
				append groupsections  aheader
				groupsectionscount += 1
				nextoffset = aheader.offset + aheader.datasize + 20			
			)--for k =1 to groupitemcount 
			--print groupsections
			for gs in groupsections do
			(
				if verbose then	
				(
					format "\t"
					amatdef = readmatdef (gs.offset+16) f true verbose
				)
				else
				(
					amatdef = readmatdef (gs.offset+16) f true false
				)
			)--for gs in groupsections
			sectionparsed = true			
		)-- if ((sections[s].specA == 5) and (sections[s].specB == 17)) 	
		
-- "12-14-0" ******************************************************************
-- Car declaration		
		if ((sections[s].specA == 14) and (sections[s].specB == 0)) then
		(
			verbose = false 
			fseek f (sections[s].offset+20) #seek_set
			handlecount = readlong f
			carhandle = readlong f
			cardeclcount  =  readlong f
			cardecl = readstring f
			optionalcardeclvalue = readstring f
			if verbose then 
			(
				print carhandle
				print cardecl
				print optionalcardeclvalue			
			)
		sectionparsed = true
		)--if ((sections[s].specA == 14) and (sections[s].specB == 0)) 
		
-- "12-20-0" ******************************************************************
-- Unk. ??
		if ((sections[s].specA == 20) and (sections[s].specB == 0)) then
		(
			--verbose = false 
			--fseek f (sections[s].offset+20) #seek_set
			sectionparsed = true
		)--if ((sections[s].specA == 20) and (sections[s].specB == 0)) 						
	if not sectionparsed then print sections[s]	
	)--for s =1 to sectionscount do	
)-- if parse then

*/

		toolMode.coordsys #world

			anode = getNodeByName "parent"
			(
				anode.pivot = [0,0,0]
				rot_obj = eulerangles 90 0 180
				rotate anode rot_obj
			)
			
			anode = getNodeByName "ghost_parent"
			(
				anode.pivot = [0,0,0]
				rot_obj = eulerangles 90 0 180
				rotate anode rot_obj
			)
			
			anode = getNodeByName "texture_dirtmap"
			(
				anode.pivot = [0,0,0]
				rot_obj = eulerangles 90 0 0
				rotate anode rot_obj
			)

			anode = getNodeByName "texture_scrapemap"
			(
				anode.pivot = [0,0,0]
				rot_obj = eulerangles 90 0 0
				rotate anode rot_obj
			)	

	fclose f	
)--if filename != undefined
)--undo off
)
